#include "icselinc.h"

static   HINSTANCE   s_hInst;
BOOL     CALLBACK    dlgfnSelIcon(HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK DllMain(HINSTANCE hInst, DWORD fdwReason, LPVOID lpv)
{
   switch (fdwReason) {
      case DLL_PROCESS_ATTACH: {
         s_hInst = hInst;
         break;
      }
      default:
         break;
   }
   return TRUE;
}

int APIENTRY SelectIconDlg(PICONSELINFO pInfo)
{
   // If we are supposed to use the file name make sure there is one
   if (!(pInfo->dwFlags & ICSEL_USEHINSTANCE) && !pInfo->pszFile)
      return -1;

   if (pInfo->dwSize != sizeof(ICONSELINFO))
      return -1;

   // We must show at least one size of icon (default to large)
   if (!(pInfo->dwFlags & ICSEL_LARGEICONS) &&
       !(pInfo->dwFlags & ICSEL_SMALLICONS))
      pInfo->dwFlags |= ICSEL_LARGEICONS;

   // Create the handler class for the dialog
   CIconSelDialog dlg(pInfo, s_hInst);

   // Display the dialog box passing it a pointer to the handler
   int iRes = DialogBoxParam(s_hInst,
                  MAKEINTRESOURCE(IDD_SELECTICON), pInfo->hwndOwner,
                  (DLGPROC)dlgfnSelIcon, (LPARAM)&dlg);
   return iRes;
}

// DIALOGPROC for the dialog box. Just calls the appropriate
// methods on the handler object
BOOL CALLBACK dlgfnSelIcon(HWND hDlg, UINT uMsg, WPARAM wParam,
                           LPARAM lParam)
{
   LPICONSELDLG pDlg = (LPICONSELDLG)GetWindowLong(hDlg, DWL_USER);

   // If there is no handler object only continue if WM_INITDIALOG
   if (!pDlg && uMsg != WM_INITDIALOG)
      return FALSE;

   switch(uMsg) {
      case WM_INITDIALOG: {
         CIconSelDialog *pDlg = (CIconSelDialog *)lParam;
         SetWindowLong(hDlg, DWL_USER, (LONG)pDlg);
         return pDlg->OnCreate(hDlg);
      }

      case WM_DRAWITEM:
         pDlg->OnDrawItem((LPDRAWITEMSTRUCT)lParam);
         break;

      case WM_COMMAND: {
         switch(LOWORD(wParam)) {
            case IDOK:
               pDlg->OnOK();
               break;

            case IDCANCEL:
               pDlg->OnCancel();
               break;

            case IDC_BROWSE:
               pDlg->OnBrowse();
               break;

            case IDC_LARGE:
            case IDC_SMALL:
               pDlg->OnSizeChange(wParam == IDC_LARGE);
               break;

            default:
               break;
         }
      }
      default:
         return FALSE;
   }
   return TRUE;
}
