#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "iconsel.h"

#define LARGE_SPACING  4
#define SMALL_SPACING  2
#define IDS_FILTERS                     1
#define IDS_NOICONS                     2
#define IDS_ERROR                       3
#define IDD_SELECTICON                  101
#define IDC_FILENAME                    1000
#define IDC_ICONLIST                    1001
#define IDC_BROWSE                      1002
#define IDC_LARGE                       1005
#define IDC_SMALL                       1006
#define IDC_LABEL_FNAME                 1007

class CIconSelDialog {
   protected:
      HWND           m_hWnd, m_hWndList;
      HIMAGELIST     m_hImgLarge, m_hImgSmall;
      BOOL           m_bLargeIcons;
      PICONSELINFO   m_pUserInfo;
      int            m_iLargeIconWidth, m_iLargeIconHeight;
      int            m_iSmallIconWidth, m_iSmallIconHeight;
      char           m_szIconFile[MAX_PATH];
      HINSTANCE      m_hInst;
      int            m_iNumIcons;

   public:
      CIconSelDialog(PICONSELINFO pInfo, HINSTANCE hInst);
      BOOL OnCreate(HWND hDlg);
      void OnCancel() { EndDialog(m_hWnd, IDCANCEL); }
      void OnOK();
      void OnBrowse();
      void OnSizeChange(BOOL bLarge);
      void OnDrawItem(LPDRAWITEMSTRUCT lpdis);
      void BuildImageLists();
      void PopulateList();
      BOOL SelectNewIconFile(LPSTR pszFile);
};

typedef CIconSelDialog * LPICONSELDLG;

